(* Daan Leijen 2001, daan@cs.uu.nl *)
open Sml

let is_white c
  = (c = ' ' || c = '\t' || c = '\n' || c == '\r')

let rec opt_spaces sctx0 c0 sctx max len acc i txt
  = if (i = max)
     then string_of_revlist_len len acc
     else let c = String.get txt i
          in  if (is_white c)
               then if (is_white c0 && sctx0 = sctx)
                     then opt_spaces sctx0 c0 sctx max len acc (i+1) txt
                     else opt_spaces sctx ' ' sctx max (len+1) (' '::acc) (i+1) txt
               else opt_spaces sctx c sctx max (len+1) (c::acc) (i+1) txt

let opt_text ctx0 c0 ctx txt
  = if (String.length txt = 0)
     then (ctx0,c0,txt)
    else if (ctx.teletype)
     then (ctx,string_last txt,txt)
     else let txt1 = opt_spaces (space_ctx ctx0) c0 (space_ctx ctx) (String.length txt) 0 [] 0 txt 
          in if (String.length txt1 = 0)
              then (ctx0,c0,txt1)
              else (ctx,string_last txt1,txt1)

let rec opt_trees ctx0 c0 ctx ts
  = match ts with
    | []  -> (ctx0,c0,[])
    | Tag (tags,body)::tt
          -> let (ctx1,c1,body1) = opt_trees ctx0 c0 (next_ctxs ctx tags) body in
             let (ctx2,c2,tt2)   = opt_trees ctx1 c1 ctx tt in
             (ctx2,c2,Tag (tags,body1)::tt2)
    | Text txt::tt
          -> let (ctx1,c1,txt1) = opt_text ctx0 c0 ctx txt in
             let (ctx2,c2,tt2)  = opt_trees ctx1 c1 ctx tt in
             if (String.length txt1 = 0)
              then (ctx2,c2,tt2)
              else (ctx2,c2,Text txt1::tt2)

(* optimize whitespace sequences *)
let opt_space ts
  = let (_,_,ts') = opt_trees root_ctx (char_of_int 0) root_ctx ts in
    ts'
    