(* Daan Leijen 2001, daan@cs.uu.nl *)
open Sml
open Print

let output_tag chan tag
  = output_string chan (string_of_tag tag)

let output_close_tag chan tag
  = begin
      output_string chan "</";
      output_tag chan tag;
      output_string chan ">"
    end

let output_open_tag chan tag
  = begin
      output_string chan "<";
      output_tag chan tag;
      output_string chan ">"
    end

let rec output_sml chan sml
  = match sml with
    | Tag (tags,[])-> ()
    | Tag (tags,xs)-> begin
                        List.iter (output_open_tag chan) tags;
                        output_smls chan xs;
                        List.iter (output_close_tag chan) (List.rev tags);
                      end
    | Text txt     -> output_string chan txt

and output_smls chan smls
  = List.iter (output_sml chan) smls

(* output an SML tree to a channel *)
let print chan smls
  = output_smls chan smls
    