(* Daan Leijen 2001, daan@cs.uu.nl *)
(* SML trees *)
type tag =
  | B
  | EM
  | I
  | PL
  | S
  | TT
  | U
  | Size  of int
  | Color of char

type sml =
  | Tag  of tag list * sml list
  | Text of string

val is_size : tag -> bool
val is_color : tag -> bool
val string_of_tag : tag -> string
val size_of_tags  : tag list -> int
val size_of_trees : sml list -> int
val is_pl_sensitive : tag -> bool

(* contexts *)
type context =
  { bold      : bool
  ; italic    : bool
  ; teletype  : bool
  ; emph      : bool
  ; strong    : bool
  ; underline : int
  ; size      : int
  ; color     : char
  }


val root_ctx  : context
val space_ctx : context -> context
val next_ctx  : context -> tag -> context
val next_ctxs : context -> tag list -> context

(* Utility functions *)
val null : 'a list -> bool
val string_last : string -> char
val string_of_revlist_len : int -> char list -> string
val string_of_list_len : int -> char list -> string
val string_of_list : char list -> string